// Copyright (c) 2013 Dave Cannon.  All rights reserved.

// $Id: rtc.s, v 2.03 26-December-2013 16:26:22 GMT rn Exp $

	.file	"rtc.s"

# Compilation/debugging switches:
				.set C_STACK,1					# enable/disable stacktrace() for the c stack rather than the BCPL stack

#				.set DEBUG_ALL,1				# enable/disable comprehensive diagnostics output


.ifdef DEBUG_ALL
				.set DEBUG_8,1					# comprehensive diagnostics
.endif
.ifdef DEBUG_8
				.set DEBUG_4,1					# extensive diagnostics...
.endif
.ifdef DEBUG_4
				.set DEBUG_2,1					# interesting diagnostics...
.endif
.ifdef DEBUG_2
				.set DEBUG,1					# minimal diagnostics...
.endif

# BCPL Manifest constants:
				.set STRSIZ,256
				.set FTsize,168					# 21 words for _ft, a further 21 for filename pointers

				.set FD.STDIN,0
				.set FD.STDOUT,1

				.set ENDSTREAMCH,-1

# BCPL Globals:
				.set START,1
				.set FILETABLE,48
				.set STACKBASE,95
				.set STACKEND,96
				.set ARGC,97
				.set ARGV,98
				.set PARAM,99

# BCPL stacksize (bytes):
				.set STKSIZ,0x400000

# BCPL File table:
				.lcomm _ft,FTsize,32
				.lcomm _fi,4,4
				.lcomm _fo,4,4
				.lcomm _ch,4,4

# c stack address:
				.lcomm	c_stackbase,4

				
	.def	___main;	.scl	2;	.type	32;	.endef

# Run-time module macros:
# Recover the BCPL environment after a call to the c library:
   .macro c_call c_func
		call	\c_func					# call the requested c library function
		mov		$G, %edi				# restore address of BCPL GLOBAL vector area
   .endm
	
	
	.section .rdata,"dr"
	.align 4
LCa:
	.ascii "\11START called, address of GLOBAL vector is %d\12\0"
LCb:
	.ascii "\11\11G:%d = %d\12\0"
	.text
#	_main is the first piece of user code called by the c start-up code.
#	It establishes %esp and its relationship with %ebp...
.globl _main
	.def	_main;	.scl	2;	.type	32;	.endef
_main:
	pushl	%ebp
	movl	%ebp, %eax					# get address of current stackframe to establish base of c stack
	movl	%esp, %ebp
	movl	%ebp, c_stackbase
	andl	$-16, %esp
#	subl	$40, %esp					# protect stackframe variables
	subl	$48, %esp					# protect stackframe variables
#
	movl	8(%ebp), %eax				# collect argc...
	movl	%eax, 20(%esp)				# ...and save locally
	movl	12(%ebp), %eax				# collect address of argv[]...
	movl	%eax, 24(%esp)				# ...and save
	push	$STKSIZ
	c_call	_malloc						# request space for BCPL stack
	pop		%ecx
#
	movl	$G, %edi					# get address of BCPL GLOBAL vector area
	movl	%edi, %edx
	shrl	$2,%edx						# convert to BCPL word address
	movl	%edx, (%edi)				# ...Global 0 now holds the address of the Global vector
#
	shrl	$2,%eax						# convert byte address to BCPL word
	mov		%eax,STACKBASE*4(%edi)		# save in GLOBAL vector 95 (STACKBASE)
	addl	$STKSIZ>>2,%eax				# derive address of end of stack
	mov		%eax,STACKEND*4(%edi)		# Save in GLOBAL vector 96 (STACKEND)
#
	c_call	___main
#  (c_call	___main:
#	call ___main
#		push	%eip
#			%esp := %esp - 4
#			%ss:%esp := SOURCE			# dword assignment
#		%eip := %eip + rel32
#	mov		$G, %edi)					# restore address of BCPL GLOBAL vector area

.ifdef DEBUG_ALL	# List out the GLOBAL vector table...
#				start diagnostics...
	movl	$G, 4(%esp)
	movl	$LCa, (%esp)
	c_call	_printf
	movl	$0, 28(%esp)
	jmp	L2
L3:
	movl	$G, %eax
	movl	28(%esp), %edx
	sall	$2, %edx
	addl	%edx, %eax
	movl	(%eax), %eax
	movl	%eax, 8(%esp)
	movl	28(%esp), %eax
	movl	%eax, 4(%esp)
	movl	$LCb, (%esp)
	c_call	_printf
	incl	28(%esp)
L2:
	cmpl	$100, 28(%esp)
	jle	L3
#				end diagnostics...		
.endif
#				convert c's argv and argc to something BCPL can cope with:
	movl	8(%ebp), %eax				# collect argc
	testl	%eax, %eax
	jne	A9
	incl	%eax						# need at least one slot for empty param string
A9:
	sall	$2, %eax
	movl	%eax, (%esp)
	c_call	_malloc						# get a vector large enough for argc pointers...
	movl	%eax, 40(%esp)				# new home for BCPL_argv
	movl	$1, 28(%esp)				# i=1
	jmp	A4
A7:
	movl	28(%esp), %eax
	sall	$2, %eax
	addl	12(%ebp), %eax				# collect argv[i]
	movl	(%eax), %eax
	movl	%eax, (%esp)
	call	_strlen						# get argv[i]'s string length...
	movl	%eax, 36(%esp)				# ...s = strlen(argv[i])
	movl	36(%esp), %eax
	addl	$5, %eax					# s=s+5
	andl	$-4, %eax					# length, modulo four
	movl	%eax, (%esp)
	c_call	_malloc						# get nxarg, new home for argv[i]
	addl	$3, %eax
	andl	$-4, %eax					# address, modulo four, to align on word boundary, for...
	movl	%eax, 44(%esp)				# ...nxarg = malloc(s+1)
	movl	$0, 32(%esp)				# j = 0
	jmp	A5
A6:
	incl	32(%esp)					# j++
A5:
	movl	32(%esp), %eax
	incl	%eax
	addl	44(%esp), %eax				# nxarg[j+1]
	movl	28(%esp), %edx
	sall	$2, %edx
	addl	12(%ebp), %edx
	movl	(%edx), %ecx
	movl	32(%esp), %edx
	leal	(%ecx,%edx), %edx			# argv[i][j]
	movb	(%edx), %dl
	movb	%dl, (%eax)					# nxarg[j+1] = argv[i][j]
	movb	(%eax), %al
	testb	%al, %al
	jne	A6								# != '\0' ?
	movl	36(%esp), %eax
	movb	%al, %dl
	movl	44(%esp), %eax
	movb	%dl, (%eax)					# nxarg[0] = s
	movl	28(%esp), %eax
	decl	%eax
	sall	$2, %eax
	addl	40(%esp), %eax
	movl	44(%esp), %edx
	shrl	$2, %edx					# convert byte address to BCPL word
	movl	%edx, (%eax)				# BCPL_argv[i-1] = nxarg
	incl	28(%esp)					# i=i+1
A4:
	movl	28(%esp), %eax
	cmpl	8(%ebp), %eax				# collect argc
	jl	A7								# i<argc ?
	movl	8(%ebp), %eax
	cmpl	$1, %eax					# any parameters at all?
	jne	A10								# yes
	movl	$4, (%esp)
	c_call	_malloc						# get vector for null string
	addl	$3, %eax
	andl	$-4, %eax					# address, modulo four, to align on word boundary, for...
	movl	%eax, %edx					# ...nxarg = malloc(4)
	movb	$0, (%edx)
	shrl	$2, %edx					# convert byte address to BCPL word
	movl	40(%esp), %eax
	movl	%edx, (%eax)				# BCPL_argv[0] = ""
	movl	$1, %eax					# argc=1
A10:
#
		#	This is the BCPL environment - set up the BCPL stack
	decl	%eax						# argc=argc-1
	movl	%eax, (%esp)				# pass argc...
	movl	%eax, ARGC*4(%edi)			# Define Global ARGC
	movl	40(%esp), %eax				# get address of BCPL_argv[]
	shrl	$2,%eax						# convert byte address to BCPL word
	movl	%eax, 4(%esp)				# ...and address of BCPL_argv[] to initbcpl()...
	movl	%eax, ARGV*4(%edi)			# Define Global ARGV
	cmpl	$1, %eax					# argv=0 ?
	jl	A8
	movl	(,%eax,4),%ecx
	jecxz	A8
	movl	%ecx, %eax
A8:
	movl	%eax, PARAM*4(%edi)			# Global PARAM points to argv[0]
	movl	20(%esp), %eax
	c_call	_initbcpl					# Switch to BCPL stack, jump to BCPL START() function
	leave								# ...this will never be executed - finish is called from BCPL
#  (leave:
#		movl	%ebp, %esp				# then...
#		pop		%ebp
#			%ebp := (%esp)
#			%esp := %esp - 4
	ret
	
	
	.section .rdata,"dr"
	.align 4
LC1:
	.ascii "\12\11_rtinit() called...\0"
LC2:
	.ascii "\11\11ft[%d] = %d\12\0"
	.text
.globl _rtinit
	.def	_rtinit;	.scl	2;	.type	32;	.endef
_rtinit:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$40, %esp
.ifdef DEBUG_ALL
#				start diagnostics...		
	movl	$LC1, (%esp)
	c_call	_puts
#				end diagnostics...		
.endif
	movl	__imp___iob, %eax
	movl	%eax, _ft					# set _ft!0 to STDIN
	movl	$0, _fi
	movl	__imp___iob, %eax
	addl	$32, %eax
	movl	%eax, _ft+4					# set _ft!1 to STDOUT
	movl	$1, _fo
	movl	__imp___iob, %eax
	addl	$64, %eax
	movl	%eax, _ft+8					# set _ft!2 to STDERR
	movl	$3, -12(%ebp)
	jmp	L4
L5:
	movl	-12(%ebp), %eax
	movl	$0, _ft(,%eax,4)
	incl	-12(%ebp)
L4:
	cmpl	$20, -12(%ebp)
	jle	L5
	movl	$_ft, %eax					# get address of the File Table
	shrl	$2, %eax					# convert byte address to BCPL word address
	mov		$G, %edi					# get address of BCPL GLOBAL vector area
	movl	%eax, FILETABLE*4(%edi)		# Save in GLOBAL vector 48 (FILETABLE)
.ifdef DEBUG	# List out the file definition table...
#				start diagnostics...		
	movl	$0, -12(%ebp)
	jmp	L6
L7:
	movl	-12(%ebp), %eax
	movl	_ft(,%eax,4), %eax
	movl	%eax, 8(%esp)
	movl	-12(%ebp), %eax
	movl	%eax, 4(%esp)
	movl	$LC2, (%esp)
	c_call	_printf
	incl	-12(%ebp)
L6:
	cmpl	$20, -12(%ebp)
	jle	L7
#				end diagnostics...		
.endif
	movl	_ft+4, %eax
	movl	16(%eax), %eax
	leave
	ret
	
	
	.section .rdata,"dr"
	.align 4
LC3:
	.ascii "\11_rtexit() called...\0"
	.text
.globl _rtexit
	.def	_rtexit;	.scl	2;	.type	32;	.endef
_rtexit:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$40, %esp
.ifdef DEBUG
#				start diagnostics...		
	movl	$LC3, (%esp)
	c_call	_puts
#				end diagnostics...		
.endif
	movl	$3, -12(%ebp)
	jmp	L10
L12:
	movl	-12(%ebp), %eax
	movl	_ft(,%eax,4), %eax
	testl	%eax, %eax
	je	L11
	movl	-12(%ebp), %eax
	movl	_ft(,%eax,4), %eax
	movl	%eax, (%esp)
	c_call	_fclose
	movl	-12(%ebp), %eax
	movl	$0, _ft(,%eax,4)
L11:
	incl	-12(%ebp)
L10:
	cmpl	$20, -12(%ebp)
	jle	L12
	leave
	ret
	
	
	.section .rdata,"dr"
	.align 4
LC4:
	.ascii "\11_sbrk(%d) called...\12\0"
	.text
.globl _sbrk
	.def	_sbrk;	.scl	2;	.type	32;	.endef
_sbrk:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
#	movl	8(%ebp), %eax
.ifdef DEBUG
#				start diagnostics...		
	movl	%eax, 4(%esp)
	movl	$LC4, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
#	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	c_call	_malloc
	leave
	ret
	
	
	.section .rdata,"dr"
	.align 4
LC5:
	.ascii "\11_cstr() called...\12\0"
LC6:
	.ascii "\11\11...returning: %s\12\0"
	.text
	.def	_cstr;	.scl	3;	.type	32;	.endef
_cstr:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$40, %esp
.ifdef DEBUG_ALL
#				start diagnostics...		
	movl	$LC5, (%esp)
	c_call	_puts
#				end diagnostics...		
.endif
	movl	8(%ebp), %eax
	movl	%eax, -20(%ebp)
	movl	-20(%ebp), %eax
	movb	(%eax), %al
	movsbl	%al,%eax
	movl	%eax, -16(%ebp)
	movl	-16(%ebp), %eax
	incl	%eax
	movl	%eax, (%esp)
	c_call	_malloc
	movl	%eax, -24(%ebp)
	movl	$1, -12(%ebp)
	jmp	L17
L18:
	movl	-12(%ebp), %eax
	decl	%eax
	addl	-24(%ebp), %eax
	movl	-12(%ebp), %edx
	addl	-20(%ebp), %edx
	movb	(%edx), %dl
	cmpb	$47, %dl					# on-the-fly UNIX to Windows pathname correction:  if this character is a '/'...
	jne	1f
	movb	$92, %dl					# ...substitute a '\'
1:
	movb	%dl, (%eax)
	incl	-12(%ebp)
L17:
	movl	-12(%ebp), %eax
	cmpl	-16(%ebp), %eax
	jle	L18
	movl	-16(%ebp), %eax
	addl	-24(%ebp), %eax
	movb	$0, (%eax)
.ifdef DEBUG_ALL
#				start diagnostics...		
	movl	-24(%ebp), %eax
	movl	%eax, 4(%esp)
	movl	$LC6, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	-24(%ebp), %eax
	leave
	ret
	
	
	.section .rdata,"dr"
	.align 4
LC7:
	.ascii "\11_ftslot() called...\12\0"
LC8:
	.ascii "\11\11...returning: %d\12\0"
	.text
	.def	_ftslot;	.scl	3;	.type	32;	.endef
_ftslot:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$40, %esp
#	movl	-12(%ebp), %eax
.ifdef DEBUG_ALL
#				start diagnostics...		
	movl	%eax, 4(%esp)
	movl	$LC7, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	$2, -12(%ebp)
	jmp	L21
L24:
	movl	-12(%ebp), %eax
	movl	_ft(,%eax,4), %eax
	testl	%eax, %eax
	jne	L22
	movl	-12(%ebp), %eax
.ifdef DEBUG_ALL
#				start diagnostics...		
	movl	%eax, 4(%esp)
	movl	$LC8, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	-12(%ebp), %eax
	jmp	L23
L22:
	incl	-12(%ebp)
L21:
	cmpl	$20, -12(%ebp)
	jle	L24
	movl	$0, %eax
L23:
	leave
	ret


// BCPL library routines:

// On entry, ecx addresses the stack frame.  A result is returned in eax.
//
// ebp, edi must be preserved:
// ebp addresses the caller's stack frame and edi the global vector.
//
// ebx and esi are also preserved although they are not currently used by
// Robert Nordier's code generator.  eax, ecx, edx need not be preserved.

	
// STACKTRACE()

	.section .rdata,"dr"
	.align 4
LC24:
	.ascii "\11stacktrace() called...\0"
LC25:
	.ascii "\11\11STACKBASE (G:%d)=%d\11STACKEND (G:%d)=%d\12\11\11%%ebp=%d\11%%esp=%d\11c_stack=%d\12\12\0"
LCd:
	.ascii "\11\11STK | %d = %d\12\0"
	.text
.globl stacktrace
	.def	stacktrace;	.scl	2;	.type	32;	.endef
stacktrace:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$40, %esp
	movl	$LC24, (%esp)
	c_call	_puts
	movl	c_stackbase, %eax
	movl	%eax, 28(%esp)				# address of c stackbase
	movl	%esp, %ecx
	shr		$2,%ecx
	movl	%ecx, 24(%esp)				# %esp
	movl	%ebp, %ecx
	shr		$2,%ecx
	movl	%ecx, 20(%esp)				# %ebp
	movl	$G, %eax
	addl	$STACKEND*4, %eax			# pick up...
	movl	(%eax), %eax				# ...address of STACKEND
	movl	%eax, 16(%esp)
	movl	$STACKEND, 12(%esp)			# Global # STACKEND
	movl	$G, %eax
	addl	$STACKBASE*4, %eax			# pick up...
	movl	(%eax), %eax				#  ...address of STACKBASE
	movl	%eax, 8(%esp)
	movl	$STACKBASE, 4(%esp)			# Global # STACKBASE
	movl	$LC25, (%esp)				# @"\11\11STACKBASE (G:%d)=%d\11STACKEND (G:%d)=%d\12\11\11%%ebp=%d\11%%esp=%d\11c_stack=%d\12\12\0"
	c_call	_printf
#
.ifdef C_STACK
	movl	c_stackbase, %eax			# trace the c stack...
	shrl	$2, %eax
.else
	movl	$G, %eax
	addl	$216, %eax					# pick up...
	movl	(%eax), %eax				#  ...address of STACKBASE
	subl	$4, %eax					# ...look before STACKBASE
.endif
	movl	%eax, 28(%esp)
	jmp	LL2
LL3:
	movl	28(%esp), %edx
	shll	$2, %edx
	movl	%edx, %eax
	movl	(%eax), %eax
	movl	%eax, 8(%esp)				#  ...contents of stack location
	shrl	$2, %edx
	movl	%edx, 4(%esp)				#  ...address of stack location
	movl	$LCd, (%esp)				# @"\11\11STK | %d = %d\12\0"
	c_call	_printf
.ifdef C_STACK
	decl	28(%esp)					# trace the c stack
.else
	incl	28(%esp)					# the BCPL stack
.endif
LL2:
	movl	28(%esp), %edx
	shll	$2, %edx
.ifdef C_STACK
	cmpl	%esp, %edx					# trace the c stack
	jge	LL3								# trace the c stack
.else
	cmpl	%ebp, %edx					# the BCPL stack
	jle	LL3
.endif
#
	leave
	ret


// SELECTINPUT(N)

	.section .rdata,"dr"
	.align 4
LC16:
	.ascii "\11selectinput(%d) called\12\0"
	.text
.globl selectinput
	.def	selectinput;	.scl	2;	.type	32;	.endef
selectinput:
	movl	8(%ecx), %eax				# recover calling argument
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
#	movl	8(%ebp), %eax
	movl	%eax, _fi
#	movl	8(%ebp), %eax
.ifdef DEBUG
#				start diagnostics...		
	movl	%eax, 4(%esp)
	movl	$LC16, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	leave
	ret
	
	
// SELECTOUTPUT(N)

	.section .rdata,"dr"
	.align 4
LC17:
	.ascii "\11selectoutput(%d) called\12\0"
	.text
.globl selectoutput
	.def	selectoutput;	.scl	2;	.type	32;	.endef
selectoutput:
	movl	8(%ecx), %eax				# recover calling argument
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
#	movl	8(%ebp), %eax
	movl	%eax, _fo
#	movl	8(%ebp), %eax
.ifdef DEBUG
#				start diagnostics...		
	movl	%eax, 4(%esp)
	movl	$LC17, (%esp)
	c_call	_printf
	movl	_fo, %eax
#				end diagnostics...		
.endif
	leave
	ret
	
	
// CH := RDCH()

	.section .rdata,"dr"
	.align 4
LC14:
	.ascii "\11rdch() called, returning '%c'\12\0"
LD14:
	.ascii "\11rdch() %%esp: '%d'\12\0"
	.text
.globl rdch
	.def	rdch;	.scl	2;	.type	32;	.endef
rdch:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$40, %esp
	movl	_fi, %eax
	movl	_ft(,%eax,4), %eax
	movl	%eax, (%esp)
	c_call	_fgetc
	movl	%eax, _ch
.ifdef DEBUG_ALL
#				start diagnostics...		
	movl	%eax, 4(%esp)
	movl	$LC14, (%esp)
	c_call	_printf
#	c_call	stacktrace
	movl	4(%esp), %eax
#				end diagnostics...		
.endif
	cmpl	$-1, %eax
	jne		L37
	movl	$ENDSTREAMCH, 4(%esp)
L37:
#	movl	4(%esp), %eax
	leave
	ret
	
	
// WRCH(CH)

	.section .rdata,"dr"
	.align 4
LC13:
	.ascii "\11wrch(%c) called\12\0"
	.text
.globl wrch
	.def	wrch;	.scl	2;	.type	32;	.endef
wrch:
	movl	8(%ecx), %eax				# recover calling argument
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
#	movl	8(%ebp), %eax
.ifdef DEBUG_ALL
#				start diagnostics...		
	movl	%eax, 4(%esp)
	movl	$LC13, (%esp)
	c_call	_printf
	c_call	stacktrace
	movl	4(%esp), %eax
#				end diagnostics...		
.endif
	movl	_fo, %ecx
	movl	_ft(,%ecx,4), %ecx
	movl	%ecx, 4(%esp)
#	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	c_call	_fputc
	leave
	ret
	
	
// UNRDCH()

	.section .rdata,"dr"
	.align 4
LC15:
	.ascii "\11unrdch(%c) called\12\0"
	.text
.globl unrdch
	.def	unrdch;	.scl	2;	.type	32;	.endef
unrdch:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
.ifdef DEBUG_4
#				start diagnostics...		
	movl	$LC15, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	_fi, %eax
	movl	_ft(,%eax,4), %edx
#	movl	_fi, %eax
#	movl	_ft(,%eax,4), %eax
#	movl	20(%eax), %eax
	movl	_ch, %eax
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	c_call	_ungetc
	leave
	ret
	
	
// STREAM := INPUT()

	.section .rdata,"dr"
	.align 4
LC18:
	.ascii "\11input() called, returning: %d\12\0"
	.text
.globl input
	.def	input;	.scl	2;	.type	32;	.endef
input:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
.ifdef DEBUG
#				start diagnostics...		
	movl	_fi, %eax
	movl	%eax, 4(%esp)
	movl	$LC18, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	_fi, %eax
	leave
	ret
	
	
// STREAM := OUTPUT()

	.section .rdata,"dr"
	.align 4
LC19:
	.ascii "\11output() called, returning: %d\12\0"
	.text
.globl output
	.def	output;	.scl	2;	.type	32;	.endef
output:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
.ifdef DEBUG
#				start diagnostics...		
	movl	_fo, %eax
	movl	%eax, 4(%esp)
	movl	$LC19, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	_fo, %eax
	leave
	ret
	
	
// PTR := TIME()

	.section .rdata,"dr"
	.align 4
LT19:
	.ascii "\11time() called, returning: %d\12\0"
	.text
.globl time
	.def	time;	.scl	2;	.type	32;	.endef
time:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$32, %esp
	leal	24(%esp), %eax
	movl	%eax, (%esp)
	c_call	_time						# get time (seconds) since epoch
	leal	24(%esp), %eax
	movl	%eax, (%esp)
	c_call	_localtime					# convert to array of years, months, days, hours, minutes and seconds...
	movl	%eax, 28(%esp)
.ifdef DEBUG
#				start diagnostics...		
	movl	24(%esp), %eax
	movl	%eax, 4(%esp)
	movl	$LT19, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	28(%esp), %eax
	shrl	$2, %eax					# ...and return (BCPL) pointer to array
	leave
	ret
	
	
// STOP(N)

	.section .rdata,"dr"
	.align 4
LS1:
	.ascii "\11stop(%d) called:\12\0"
	.text
.globl stop
	.def	stop;	.scl	2;	.type	32;	.endef
stop:
	pop		%eax
	mov		8(%ecx),%eax
	jmp		_stop


// P := LEVEL()

	.section .rdata,"dr"
	.align 4
LL1:
	.ascii "\11level() called, returning: %d\12\0"
	.text
.globl level
	.def	level;	.scl	2;	.type	32;	.endef
level:
	mov		%ebp,%eax
	ret


// LONGJUMP(P, L)

	.section .rdata,"dr"
	.align 4
LJ1:
	.ascii "\11longjump(%d, %d) called:\12\0"
	.text
.globl longjump
	.def	longjump;	.scl	2;	.type	32;	.endef
longjump:
	pop		%eax
	mov		8(%ecx),%ebp
	jmp		*12(%ecx)


// REWIND()

	.section .rdata,"dr"
	.align 4
LC22:
	.ascii "\11rewind() called on stream '%d'...\12\0"
	.text
.globl rewind
	.def	rewind;	.scl	2;	.type	32;	.endef
rewind:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
.ifdef DEBUG
#				start diagnostics...
	movl	_fi, %eax
	movl	%eax, 4(%esp)
	movl	$LC22, (%esp)
	c_call	_printf
#				end diagnostics...
.endif
#	movl	8(%ebp), %eax
	movl	_fi, %eax
	movl	_ft(,%eax,4), %eax
	movl	%eax, (%esp)
	c_call	_rewind
	leave
	ret


// RESULT := APTOVEC(F, N)

	.section .rdata,"dr"
	.align 4
LA1:
	.ascii "\11aptovec(%d, %d) called:\12\0"
	.text
.globl aptovec
	.def	aptovec;	.scl	2;	.type	32;	.endef
aptovec:
	mov		12(%ecx),%edx		# Collect SIZE (in words)
	mov		%edx,%eax
	inc		%eax				# increment SIZE
	shl		$2,%eax				# convert SIZE to bytes
	add		%ecx,%eax			# calculate new frame base address in %eax
	xchg	%ecx,%eax			# (%ecx is now new frame base address, %eax is now current frame base address)
	mov		%edx,12(%ecx)		# save requested SIZE (words) in new stack frame
	mov		%eax,%edx			# ...current frame base address
	shr		$2,%eax				# convert current frame base address to words
	mov		%eax,8(%ecx)		# save current frame base address (words) in new stack frame
	jmp		*8(%edx)			# jump to nominated function...


// STREAM := FINDFILE(S, M)

	.section .rdata,"dr"
	.align 4
LF11:
	.ascii "\11findfile(\"%s\", \"%s\") called\12\0"
	.text
.globl findfile
	.def	findfile;	.scl	2;	.type	32;	.endef
findfile:
	movl	8(%ecx), %eax				# recover calling filename argument...
	movl	12(%ecx), %ecx				# ...and access mode
findf:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	subl	$40, %esp
	movl	%eax, -20(%ebp)				# save (word) address of BCPL filename string...
	movl	%ecx, -24(%ebp)				# ...and (word) address of BCPL access mode string
#										# copy BCPL filename...
	shl		$2,%eax						# convert BCPL pointer to real address
	movl	%eax, (%esp)				# pass (real) address of BCPL filename string
	c_call	_cstr
	movl	%eax, -16(%ebp)				# save address of c filename string
#										# copy BCPL access mode...
	movl	-24(%ebp),%eax
	shl		$2,%eax						# convert BCPL pointer to real address
	movl	%eax, (%esp)				# pass (real) address of BCPL access mode string
	c_call	_cstr
	movl	%eax, -28(%ebp)				# save address of c access mode string
.ifdef DEBUG
#				start diagnostics...
	movl	%eax, 8(%esp)
	movl	-16(%ebp), %eax
	movl	%eax, 4(%esp)
	movl	$LF11, (%esp)
	c_call	_printf
#				end diagnostics...
.endif
	c_call	_ftslot
	movl	%eax, -12(%ebp)
	cmpl	$0, -12(%ebp)				# any _ft slot available?
	je	1f								# no...
	movl	-28(%ebp), %eax				# collect access mode string...
	movl	%eax, 4(%esp)
	movl	-16(%ebp), %eax				# ...and filename arguments
	movl	%eax, (%esp)
	c_call	_fopen
	movl	-12(%ebp), %ebx
	movl	%eax, _ft(,%ebx,4)			# save file descriptor in _ft location
	movl	-12(%ebp), %eax
	movl	_ft(,%eax,4), %eax
	testl	%eax, %eax					# is there a file descriptor?
	je	2f								# no, file failed to open
	addl	$21, %ebx					# point %ebx to filename location in _ft
	movl	-20(%ebp), %eax				# recover (word) address of BCPL filename string
	movl	%eax, _ft(,%ebx,4)			# set _ft location to point to BCPL filename
	jmp	1f
2:
	movl	$0, -12(%ebp)
1:
	movl	-16(%ebp), %eax				# address of c filename string
	movl	%eax, (%esp)
	c_call	_free						# release spaces...
	movl	-28(%ebp), %eax				# address of c access mode string
	movl	%eax, (%esp)
	c_call	_free						# ...occupied by c strings
	movl	-12(%ebp), %eax
#	incl	%eax
	addl	$40, %esp
	popl	%ebx
	leave
	ret
	
	
// STREAM := FINDOUTPUT(S)

	.section .rdata,"dr"
	.align 4							# this is crucial - following BCPL string MUST be word aligned!
LW10:
	.ascii "\1w"						# access mode = write
	.text
.globl findoutput
	.def	findoutput;	.scl	2;	.type	32;	.endef
findoutput:
	movl	8(%ecx), %eax				# recover calling filename argument...
	movl	$LW10, %ecx
	shrl	$2, %ecx					# (BCPL word) pointer to access mode
	jmp findf							# arguments are now set for findfile(filename, access_mode)
	
	
// STREAM := FINDINPUT(S)

	.section .rdata,"dr"
	.align 4							# this is crucial - following BCPL string MUST be word aligned!
LR10:
	.ascii "\1r"						# access mode = read
	.text
.globl findinput
	.def	findinput;	.scl	2;	.type	32;	.endef
findinput:
	movl	8(%ecx), %eax				# recover calling filename argument...
	movl	$LR10, %ecx
	shrl	$2, %ecx					# (BCPL word) pointer to access mode
	jmp findf							# arguments are now set for findfile(filename, access_mode)
	
	
// STREAM := FINDAPPEND(S)

	.section .rdata,"dr"
	.align 4							# this is crucial - following BCPL string MUST be word aligned!
LA10:
	.ascii "\1a"						# access mode = append
	.text
.globl findappend
	.def	findappend;	.scl	2;	.type	32;	.endef
findappend:
	movl	8(%ecx), %eax				# recover calling filename argument...
	movl	$LA10, %ecx
	shrl	$2, %ecx					# (BCPL word) pointer to access mode
	jmp findf							# arguments are now set for findfile(filename, access_mode)
	
	
// ENDSTREAM(N)

	.section .rdata,"dr"
	.align 4
LE20:
	.ascii "\11endstream(%d) called...\12\0"
	.text
.globl endstream
	.def	endstream;	.scl	2;	.type	32;	.endef
endstream:
	movl	8(%ebp), %eax				# recover calling stream id...
ends:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
	movl	%eax, -16(%ebp)				# record stream id...
.ifdef DEBUG
#				start diagnostics...		
#	movl	_fi, %eax
	movl	%eax, 4(%esp)
	movl	$LE20, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	-16(%ebp), %eax				# collect stream id...
	cmpl	$2, %eax					# SYSIN, SYSOUT or SYSERR?
	jle	1f								# ...if so, don't close
#	movl	_fi, %eax
	movl	_ft(,%eax,4), %eax			# collect address of file descriptor
	movl	%eax, (%esp)
	c_call	_fclose
	movl	-16(%ebp), %eax				# collect stream id...
	movl	$0, _ft(,%eax,4)
1:
	cmpl	$2, %eax					# were we closing a SYS... stream?
	jg	2f								# no
	cmpl	_fo, %eax					# closing SYSOUT or SYSERR?
	jne 2f								# no - no need to flush
#	movl	_fo, %eax
	movl	_ft(,%eax,4), %eax
	movl	%eax, (%esp)
	c_call	_fflush
2:
	movl	-16(%ebp), %eax				# collect stream id...
	cmpl	_fi, %eax
	jne	1f								# if closing current input...
	movl	$0, _fi						# select SYSIN
	jmp	2f
1:	
	movl	$1, _fo						# otherwise select SYSOUT as current output
2:
	leave
	ret
	
	
// ENDREAD()

	.section .rdata,"dr"
	.align 4
LC20:
	.ascii "\11endread(%d) called...\12\0"
	.text
.globl endread
	.def	endread;	.scl	2;	.type	32;	.endef
endread:
	movl	_fi, %eax
	jmp	ends
	
	
// ENDWRITE()

	.section .rdata,"dr"
	.align 4
LC21:
	.ascii "\11endwrite(%d) called...\12\0"
	.text
.globl endwrite
	.def	endwrite;	.scl	2;	.type	32;	.endef
endwrite:
	movl	_fo, %eax
	jmp ends
	
	
// R := RENAME(S1, S2)

	.section .rdata,"dr"
	.align 4
LR11:
	.ascii "\11rename(\"%s, %s\") called\12\0"
	.text
.globl rename
	.def	rename;	.scl	2;	.type	32;	.endef
rename:
	movl	8(%ecx), %eax				# recover old filename argument
	movl	12(%ecx), %ecx				# recover new filename argument
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	subl	$40, %esp
	movl	%eax, -20(%ebp)				# save BCPL address of old filename string
	movl	%ecx, -24(%ebp)				# save BCPL address of new filename string
#										# copy BCPL old filename...
	shl		$2,%eax						# convert BCPL pointer to real address
	movl	%eax, (%esp)				# pass (real) address of BCPL filename string
	c_call	_cstr
	movl	%eax, -16(%ebp)				# save address of old c filename string
#										# copy BCPL new filename...
	movl	-24(%ebp), %eax				# recover BCPL address of new filename string
	shl		$2,%eax						# convert BCPL pointer to real address
	movl	%eax, (%esp)				# pass (real) address of BCPL filename string
	c_call	_cstr
	movl	%eax, -28(%ebp)				# save address of new c filename string
.ifdef DEBUG
#				start diagnostics...		
	movl	%eax, 8(%esp)				# ...address of new c filename string
	movl	-16(%ebp), %ecx				# recover address of old c filename string
	movl	%ecx, 4(%esp)
	movl	$LR11, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	-28(%ebp), %eax				# recover address of new c filename string
	movl	%eax, 4(%esp)
	movl	-16(%ebp), %eax				# recover address of old c filename string
	movl	%eax, (%esp)
	c_call	_rename						# _rename appears to return -1 (fail) or 0 (success)...
	incl	%eax						# ...so we change this to 0 (fail) or 1 (success)
	movl	%eax, -12(%ebp)
	movl	-16(%ebp), %eax
	movl	%eax, (%esp)
	c_call	_free						# release space occupied by c strings...
	movl	-28(%ebp), %eax
	movl	%eax, (%esp)
	c_call	_free
	movl	-12(%ebp), %eax
#	incl	%eax
	addl	$40, %esp
	popl	%ebx
	leave
	ret
	
	
// R := DELETE(S)

	.section .rdata,"dr"
	.align 4
LD11:
	.ascii "\11delete(\"%s\") called\12\0"
	.text
.globl delete
	.def	delete;	.scl	2;	.type	32;	.endef
delete:
	movl	8(%ecx), %eax				# recover filename argument
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	subl	$36, %esp
	movl	%eax, -20(%ebp)				# save BCPL address of filename string
#										# copy BCPL filename...
	shl		$2,%eax						# convert BCPL pointer to real address
	movl	%eax, (%esp)				# pass (real) address of BCPL filename string
	c_call	_cstr
	movl	%eax, -16(%ebp)				# save address of c filename string
.ifdef DEBUG
#				start diagnostics...		
	movl	%eax, 4(%esp)
	movl	$LD11, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	-16(%ebp), %eax				# recover address of c filename string
	movl	%eax, (%esp)
	c_call	_unlink						# _unlink appears to return -1 (fail) or 0 (success)...
	incl	%eax						# ...so we change this to 0 (fail) or 1 (success)
	movl	%eax, -12(%ebp)
	movl	-16(%ebp), %eax
	movl	%eax, (%esp)
	c_call	_free						# release space occupied by c strings...
	movl	-12(%ebp), %eax
#	incl	%eax
	addl	$36, %esp
	popl	%ebx
	leave
	ret
	
	
// S := GETENV(ENVVAR)

	.section .rdata,"dr"
	.align 4
LG11:
	.ascii "\11getenv(\"%s\") called\12\0"
	.text
.globl getenv
	.def	getenv;	.scl	2;	.type	32;	.endef
getenv:
	movl	8(%ecx), %eax				# recover calling argument
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	subl	$40, %esp
	movl	%eax, -20(%ebp)				# save (word) address of BCPL environment variable string
#										# copy BCPL environment variable...
	shl		$2,%eax						# convert BCPL pointer to real address
	movl	%eax, (%esp)				# pass (real) address of BCPL environment variable string
	c_call	_cstr
	movl	%eax, -16(%ebp)				# save address of c environment variable name
.ifdef DEBUG
#				start diagnostics...		
	movl	%eax, 4(%esp)
	movl	$LG11, (%esp)
	c_call	_printf
#				end diagnostics...		
.endif
	movl	-16(%ebp), %eax				# collect c ev name
	movl	%eax, (%esp)
	c_call	_getenv
	testl	%eax, %eax					# is there a matching environment variable?
	je	LF32							# no
	movl	%eax, -12(%ebp)				# save Cev, address of the environment variable
	movl	%eax, (%esp)
	call	_strlen						# get ev's string length...
	movl	%eax, -24(%ebp)				# ...s = strlen(ev)
	movl	-24(%ebp), %eax
	addl	$2, %eax					# s=s+2
	addl	$3, %eax
	andl	$-4, %eax					# length, modulo four
	movl	%eax, (%esp)
	c_call	_malloc						# get vector for BCPL copy of string: Bev
	addl	$3, %eax
	andl	$-4, %eax					# address, modulo four, to align on word boundary...
	movl	%eax, -28(%ebp)				# ...save address of Bev
	movl	$0, -32(%ebp)				# i = 0
	jmp	G5
G6:
	incl	-32(%ebp)					# i++
G5:
	movl	-32(%ebp), %eax
	incl	%eax
	addl	-28(%ebp), %eax				# Bev[i+1]
	movl	-12(%ebp), %edx				# Cev
	addl	-32(%ebp), %edx				# Cev[i]
	movb	(%edx), %dl
	movb	%dl, (%eax)					# Bev[i+1] = Cev[i]
	movb	(%eax), %al
	testb	%al, %al
	jne	G6								# != '\0' ?
	movl	-32(%ebp), %eax				
	movb	%al, %dl
	movl	-28(%ebp), %eax
	movb	%dl, (%eax)					# Bev[0] = i
	shrl	$2, %eax					# convert byte address to BCPL word
	movl	%eax, -28(%ebp)				# ...save word address of Bev
	jmp	L32
LF32:
	movl	$0, -28(%ebp)				# set 'no env variable found'
L32:
	movl	-16(%ebp), %eax
	movl	%eax, (%esp)
	c_call	_free						# release space occupied by c string
	movl	-28(%ebp), %eax				# load result
#	incl	%eax
	addl	$40, %esp
	popl	%ebx
	leave
	ret
	
	
// I:= PACKSTRING(U, S)

	.section .rdata,"dr"
	.align 4
LK1:
	.ascii "\11packstring(\"%d, %d\") called\12\0"
	.text
.globl packstring
	.def	packstring;	.scl	2;	.type	32;	.endef
packstring:
	movl	8(%ecx), %eax				# recover first argument...
	mov		12(%ecx),%ecx				# ...and the second argument
	pushl	%ebp
	movl	%esp, %ebp
#
	push	%esi
	push	%edi
	mov		%eax, %esi
	shl		$2, %esi
	mov		%ecx, %edi
	shl		$2, %edi
	lodsl
	movzx	%al, %edx
	mov		%edx, %ecx
	shr		$2, %edx
	movl	%ecx, (%edi,%edx,4)			# Zero last cell
	stosb
	jecxz	2f
1:
	lodsl
	stosb
	loop	1b
2:
	mov		%edx,%eax
	pop		%edi
	pop		%esi
	leave
	ret

// UNPACKSTRING(S, U)

	.section .rdata,"dr"
	.align 4
LU1:
	.ascii "\11unpackstring(\"%d, %d\") called\12\0"
	.text
.globl unpackstring
	.def	unpackstring;	.scl	2;	.type	32;	.endef
unpackstring:
	movl	8(%ecx), %eax				# recover first argument...
	mov		12(%ecx), %ecx				# ...and the second argument
	pushl	%ebp
	movl	%esp, %ebp
#
	push	%esi
	push	%edi
	mov		%eax, %esi
	shl		$2,%esi
	mov		%ecx, %edi
	shl		$2, %edi
	xor		%eax, %eax
	lodsb
	stosl
	mov		%eax, %ecx
	jecxz	2f
1:
	lodsb
	stosl
	loop	1b
2:
	pop		%edi
	pop		%esi
	leave
	ret


// CH := GETBYTE(V, N)

	.section .rdata,"dr"
	.align 4
LB1:
	.ascii "\11getbyte(\"%d, %d\") called\12\0"
	.text
.globl getbyte
	.def	getbyte;	.scl	2;	.type	32;	.endef
getbyte:
	movl	8(%ecx), %eax				# recover calling argument
	shl		$2, %eax
	add		12(%ecx), %eax
	movzb	(%eax), %eax
	ret


// PUTBYTE(V, N, B)

	.section .rdata,"dr"
	.align 4
LP1:
	.ascii "\11putbyte(\"%d, %d, %d\") called\12\0"
	.text
.globl putbyte
	.def	putbyte;	.scl	2;	.type	32;	.endef
putbyte:
	mov		8(%ecx),%eax
	shl		$2,%eax
	add		12(%ecx),%eax
	mov		16(%ecx),%ecx
	mov		%cl,(%eax)
	ret


// V := GETVEC(SIZE)

	.section .rdata,"dr"
LC26:
	.ascii "\11getvec(%c) called\12\0"
	.text
.globl getvec
	.def	getvec;	.scl	2;	.type	32;	.endef
getvec:
	movl	8(%ecx), %eax				# recover calling argument
	incl	%eax						# ...to allow for 0 -> vecsize
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
.ifdef DEBUG
#				start diagnostics...
	movl	%eax, 4(%esp)
	movl	$LC26, (%esp)
	c_call	_printf
	movl	4(%esp), %eax
#				end diagnostics...
.endif
	shll	$2,%eax						# convert requested BCPL memory size (words) to bytes
	movl	%eax, (%esp)
	c_call	_malloc
	shrl	$2,%eax						# convert byte address to BCPL word
	leave
	ret
	
	
// FREEVEC(V)

	.section .rdata,"dr"
LC27:
	.ascii "\11freevec(%c) called\12\0"
	.text
.globl freevec
	.def	freevec;	.scl	2;	.type	32;	.endef
freevec:
	movl	8(%ecx), %eax				# recover calling argument
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
.ifdef DEBUG
#				start diagnostics...
	movl	%eax, 4(%esp)
	movl	$LC27, (%esp)
	c_call	_printf
	movl	4(%esp), %eax
#				end diagnostics...
.endif
	shll	$2,%eax						# convert BCPL word address to byte
	movl	%eax, (%esp)
	c_call	_free
	leave
	ret


	.data
	.global G11; .equ G11,selectinput
	.global G12; .equ G12,selectoutput
	.global G13; .equ G13,rdch
	.global G14; .equ G14,wrch
	.global G15; .equ G15,unrdch
	.global G16; .equ G16,input
	.global G17; .equ G17,output
	.global G28; .equ G28,time
	.global G30; .equ G30,stop
	.global G31; .equ G31,level
	.global G32; .equ G32,longjump
	.global G35; .equ G35,rewind
	.global G40; .equ G40,aptovec
	.global G41; .equ G41,findoutput
	.global G42; .equ G42,findinput
	.global G43; .equ G43,findappend
#	.global G45; .equ G45,endstream		# currently defined in blib.b
	.global G46; .equ G46,endread
	.global G47; .equ G47,endwrite
	.global G49; .equ G49,rename
	.global G50; .equ G50,delete
	.global G52; .equ G52,getenv
	.global G54; .equ G54,findfile
	.global G66; .equ G66,packstring
	.global G67; .equ G67,unpackstring
	.global G85; .equ G85,getbyte
	.global G86; .equ G86,putbyte
	.global G87; .equ G87,getvec
	.global G88; .equ G88,freevec
		
	.def	_start;		.scl	2;	.type	32;	.endef
	.def	_puts;		.scl	2;	.type	32;	.endef
	.def	_malloc;	.scl	2;	.type	32;	.endef
	.def	_fopen;		.scl	2;	.type	32;	.endef
	.def	_getenv;	.scl	2;	.type	32;	.endef
	.def	_rename;	.scl	2;	.type	32;	.endef
	.def	_unlink;	.scl	2;	.type	32;	.endef
	.def	_free;		.scl	2;	.type	32;	.endef
	.def	_fputc;		.scl	2;	.type	32;	.endef
	.def	_fgetc;		.scl	2;	.type	32;	.endef
	.def	_ungetc;	.scl	2;	.type	32;	.endef
	.def	_printf;	.scl	2;	.type	32;	.endef
	.def	_fclose;	.scl	2;	.type	32;	.endef
	.def	_fflush;	.scl	2;	.type	32;	.endef
	.def	_rewind;	.scl	2;	.type	32;	.endef
	.def	_time;		.scl	2;	.type	32;	.endef
	.def	_localtime;	.scl	2;	.type	32;	.endef
